Package com.google.gwt.aria.client

## Interface Role

- All Known Subinterfaces:
    `AlertdialogRole`, `AlertRole`, `ApplicationRole`, `ArticleRole`, `BannerRole`, `ButtonRole`, `CheckboxRole`, `ColumnheaderRole`, `ComboboxRole`, `CommandRole`, `ComplementaryRole`, `CompositeRole`, `ContentinfoRole`, `DefinitionRole`, `DialogRole`, `DirectoryRole`, `DocumentRole`, `FormRole`, `GridcellRole`, `GridRole`, `GroupRole`, `HeadingRole`, `ImgRole`, `InputRole`, `LandmarkRole`, `LinkRole`, `ListboxRole`, `ListitemRole`, `ListRole`, `LogRole`, `MainRole`, `MarqueeRole`, `MathRole`, `MenubarRole`, `MenuitemcheckboxRole`, `MenuitemradioRole`, `MenuitemRole`, `MenuRole`, `NavigationRole`, `NoteRole`, `OptionRole`, `PresentationRole`, `ProgressbarRole`, `RadiogroupRole`, `RadioRole`, `RangeRole`, `RegionRole`, `RowgroupRole`, `RowheaderRole`, `RowRole`, `ScrollbarRole`, `SearchRole`, `SectionheadRole`, `SectionRole`, `SelectRole`, `SeparatorRole`, `SliderRole`, `SpinbuttonRole`, `StatusRole`, `StructureRole`, `TablistRole`, `TabpanelRole`, `TabRole`, `TextboxRole`, `TimerRole`, `ToolbarRole`, `TooltipRole`, `TreegridRole`, `TreeitemRole`, `TreeRole`, `WidgetRole`, `WindowRole`
  All Known Implementing Classes:
    `AlertdialogRoleImpl`, `AlertRoleImpl`, `ApplicationRoleImpl`, `ArticleRoleImpl`, `BannerRoleImpl`, `ButtonRoleImpl`, `CheckboxRoleImpl`, `ColumnheaderRoleImpl`, `ComboboxRoleImpl`, `ComplementaryRoleImpl`, `ContentinfoRoleImpl`, `DefinitionRoleImpl`, `DialogRoleImpl`, `DirectoryRoleImpl`, `DocumentRoleImpl`, `FormRoleImpl`, `GridcellRoleImpl`, `GridRoleImpl`, `GroupRoleImpl`, `HeadingRoleImpl`, `ImgRoleImpl`, `LinkRoleImpl`, `ListboxRoleImpl`, `ListitemRoleImpl`, `ListRoleImpl`, `LogRoleImpl`, `MainRoleImpl`, `MarqueeRoleImpl`, `MathRoleImpl`, `MenubarRoleImpl`, `MenuitemcheckboxRoleImpl`, `MenuitemradioRoleImpl`, `MenuitemRoleImpl`, `MenuRoleImpl`, `NavigationRoleImpl`, `NoteRoleImpl`, `OptionRoleImpl`, `PresentationRoleImpl`, `ProgressbarRoleImpl`, `RadiogroupRoleImpl`, `RadioRoleImpl`, `RegionRoleImpl`, `RoleImpl`, `RowgroupRoleImpl`, `RowheaderRoleImpl`, `RowRoleImpl`, `ScrollbarRoleImpl`, `SearchRoleImpl`, `SeparatorRoleImpl`, `SliderRoleImpl`, `SpinbuttonRoleImpl`, `StatusRoleImpl`, `TablistRoleImpl`, `TabpanelRoleImpl`, `TabRoleImpl`, `TextboxRoleImpl`, `TimerRoleImpl`, `ToolbarRoleImpl`, `TooltipRoleImpl`, `TreegridRoleImpl`, `TreeitemRoleImpl`, `TreeRoleImpl`

      public interface Role

  A generic ARIA Role. This interface defines generic methods for setting, getting, and removing attributes on DOM Elements so that they can be identified by screen readers. Subtypes define methods for specific roles.

  The ARIA specification defines a hierarchy of roles, which is mirrored here as a hierarchy of Java interfaces. Some roles are abstract and define methods that are common to their children. Only concrete roles (available via methods in `Roles`) should be used to modify HTML elements.

  For more details, see The Roles Model in the ARIA specification.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String` | `getAriaAtomicProperty​(Element element)` | Returns the value of the aria-atomic attribute for the `element` or "" if no such attribute is present.
    `java.lang.String` | `getAriaBusyState​(Element element)` | Returns the value of the aria-busy attribute for the `element` or "" if no such attribute is present.
    `java.lang.String` | `getAriaControlsProperty​(Element element)` | Returns the value of the aria-controls attribute for the `element` or "" if no such attribute is present.
    `java.lang.String` | `getAriaDescribedbyProperty​(Element element)` | Returns the value of the aria-describedby attribute for the `element` or "" if no such attribute is present.
    `java.lang.String` | `getAriaDisabledState​(Element element)` | Returns the value of the aria-disabled attribute for the `element` or "" if no such attribute is present.
    `java.lang.String` | `getAriaDropeffectProperty​(Element element)` | Returns the value of the aria-dropeffect attribute for the `element` or "" if no such attribute is present.
    `java.lang.String` | `getAriaFlowtoProperty​(Element element)` | Returns the value of the aria-flowto attribute for the `element` or "" if no such attribute is present.
    `java.lang.String` | `getAriaGrabbedState​(Element element)` | Returns the value of the aria-grabbed attribute for the `element` or "" if no such attribute is present.
    `java.lang.String` | `getAriaHaspopupProperty​(Element element)` | Returns the value of the aria-haspopup attribute for the `element` or "" if no such attribute is present.
    `java.lang.String` | `getAriaHiddenState​(Element element)` | Returns the value of the aria-hidden attribute for the `element` or "" if no such attribute is present.
    `java.lang.String` | `getAriaInvalidState​(Element element)` | Returns the value of the aria-invalid attribute for the `element` or "" if no such attribute is present.
    `java.lang.String` | `getAriaLabelledbyProperty​(Element element)` | Returns the value of the aria-labelledby attribute for the `element` or "" if no such attribute is present.
    `java.lang.String` | `getAriaLabelProperty​(Element element)` | Returns the value of the aria-label attribute for the `element` or "" if no such attribute is present.
    `java.lang.String` | `getAriaLiveProperty​(Element element)` | Returns the value of the aria-live attribute for the `element` or "" if no such attribute is present.
    `java.lang.String` | `getAriaOwnsProperty​(Element element)` | Returns the value of the aria-owns attribute for the `element` or "" if no such attribute is present.
    `java.lang.String` | `getAriaRelevantProperty​(Element element)` | Returns the value of the aria-relevant attribute for the `element` or "" if no such attribute is present.
    `java.lang.String` | `getName()` | Gets the ARIA 'role' attribute name as defined in the WAI-ARIA standard.
    `java.lang.String` | `getTabindexExtraAttribute​(Element element)` | Returns the value of the tabIndex attribute for the `element` or "" if no such attribute is present.
    `void` | `remove​(Element element)` | Removes the 'role' attribute from the `element`.
    `void` | `removeAriaAtomicProperty​(Element element)` | Removes the aria-atomic attribute from the `element`.
    `void` | `removeAriaBusyState​(Element element)` | Removes the aria-busy attribute from the `element`.
    `void` | `removeAriaControlsProperty​(Element element)` | Removes the aria-controls attribute from the `element`.
    `void` | `removeAriaDescribedbyProperty​(Element element)` | Removes the aria-describedby attribute from the `element`.
    `void` | `removeAriaDisabledState​(Element element)` | Removes the aria-disabled attribute from the `element`.
    `void` | `removeAriaDropeffectProperty​(Element element)` | Removes the aria-dropeffect attribute from the `element`.
    `void` | `removeAriaFlowtoProperty​(Element element)` | Removes the aria-flowto attribute from the `element`.
    `void` | `removeAriaGrabbedState​(Element element)` | Removes the aria-grabbed attribute from the `element`.
    `void` | `removeAriaHaspopupProperty​(Element element)` | Removes the aria-haspopup attribute from the `element`.
    `void` | `removeAriaHiddenState​(Element element)` | Removes the aria-hidden attribute from the `element`.
    `void` | `removeAriaInvalidState​(Element element)` | Removes the aria-invalid attribute from the `element`.
    `void` | `removeAriaLabelledbyProperty​(Element element)` | Removes the aria-labelledby attribute from the `element`.
    `void` | `removeAriaLabelProperty​(Element element)` | Removes the aria-label attribute from the `element`.
    `void` | `removeAriaLiveProperty​(Element element)` | Removes the aria-live attribute from the `element`.
    `void` | `removeAriaOwnsProperty​(Element element)` | Removes the aria-owns attribute from the `element`.
    `void` | `removeAriaRelevantProperty​(Element element)` | Removes the aria-relevant attribute from the `element`.
    `void` | `removeTabindexExtraAttribute​(Element element)` | Removes the tabIndex attribute from the `element`.
    `void` | `set​(Element element)` | Sets the 'role' attribute of the given `element` to the appropriate value for this role.
    `void` | `setAriaAtomicProperty​(Element element, boolean value)` | Sets the aria-atomic attribute for the `element` to the given `value`.
    `void` | `setAriaBusyState​(Element element, boolean value)` | Sets the aria-busy attribute for the `element` to the given `value`.
    `void` | `setAriaControlsProperty​(Element element, Id... value)` | Sets the aria-controls attribute for the `element` to the given `value`.
    `void` | `setAriaDescribedbyProperty​(Element element, Id... value)` | Sets the aria-describedby attribute for the `element` to the given `value`.
    `void` | `setAriaDisabledState​(Element element, boolean value)` | Sets the aria-disabled attribute for the `element` to the given `value`.
    `void` | `setAriaDropeffectProperty​(Element element, DropeffectValue... value)` | Sets the aria-dropeffect attribute for the `element` to the given `value`.
    `void` | `setAriaFlowtoProperty​(Element element, Id... value)` | Sets the aria-flowto attribute for the `element` to the given `value`.
    `void` | `setAriaGrabbedState​(Element element, GrabbedValue value)` | Sets the aria-grabbed attribute for the `element` to the given `value`.
    `void` | `setAriaHaspopupProperty​(Element element, boolean value)` | Sets the aria-haspopup attribute for the `element` to the given `value`.
    `void` | `setAriaHiddenState​(Element element, boolean value)` | Sets the aria-hidden attribute for the `element` to the given `value`.
    `void` | `setAriaInvalidState​(Element element, InvalidValue value)` | Sets the aria-invalid attribute for the `element` to the given `value`.
    `void` | `setAriaLabelledbyProperty​(Element element, Id... value)` | Sets the aria-labelledby attribute for the `element` to the given `value`.
    `void` | `setAriaLabelProperty​(Element element, java.lang.String value)` | Sets the aria-label attribute for the `element` to the given `value`.
    `void` | `setAriaLiveProperty​(Element element, LiveValue value)` | Sets the aria-live attribute for the `element` to the given `value`.
    `void` | `setAriaOwnsProperty​(Element element, Id... value)` | Sets the aria-owns attribute for the `element` to the given `value`.
    `void` | `setAriaRelevantProperty​(Element element, RelevantValue... value)` | Sets the aria-relevant attribute for the `element` to the given `value`.
    `void` | `setTabindexExtraAttribute​(Element element, int value)` | Sets the tabIndex attribute for the `element` to the given `value`.

- - ### Method Detail

    - #### getAriaAtomicProperty

          java.lang.String getAriaAtomicProperty​(Element element)

      Returns the value of the aria-atomic attribute for the `element` or "" if no such attribute is present.

    - #### getAriaBusyState

          java.lang.String getAriaBusyState​(Element element)

      Returns the value of the aria-busy attribute for the `element` or "" if no such attribute is present.

    - #### getAriaControlsProperty

          java.lang.String getAriaControlsProperty​(Element element)

      Returns the value of the aria-controls attribute for the `element` or "" if no such attribute is present.

    - #### getAriaDescribedbyProperty

          java.lang.String getAriaDescribedbyProperty​(Element element)

      Returns the value of the aria-describedby attribute for the `element` or "" if no such attribute is present.

    - #### getAriaDisabledState

          java.lang.String getAriaDisabledState​(Element element)

      Returns the value of the aria-disabled attribute for the `element` or "" if no such attribute is present.

    - #### getAriaDropeffectProperty

          java.lang.String getAriaDropeffectProperty​(Element element)

      Returns the value of the aria-dropeffect attribute for the `element` or "" if no such attribute is present.

    - #### getAriaFlowtoProperty

          java.lang.String getAriaFlowtoProperty​(Element element)

      Returns the value of the aria-flowto attribute for the `element` or "" if no such attribute is present.

    - #### getAriaGrabbedState

          java.lang.String getAriaGrabbedState​(Element element)

      Returns the value of the aria-grabbed attribute for the `element` or "" if no such attribute is present.

    - #### getAriaHaspopupProperty

          java.lang.String getAriaHaspopupProperty​(Element element)

      Returns the value of the aria-haspopup attribute for the `element` or "" if no such attribute is present.

    - #### getAriaHiddenState

          java.lang.String getAriaHiddenState​(Element element)

      Returns the value of the aria-hidden attribute for the `element` or "" if no such attribute is present.

    - #### getAriaInvalidState

          java.lang.String getAriaInvalidState​(Element element)

      Returns the value of the aria-invalid attribute for the `element` or "" if no such attribute is present.

    - #### getAriaLabelledbyProperty

          java.lang.String getAriaLabelledbyProperty​(Element element)

      Returns the value of the aria-labelledby attribute for the `element` or "" if no such attribute is present.

    - #### getAriaLabelProperty

          java.lang.String getAriaLabelProperty​(Element element)

      Returns the value of the aria-label attribute for the `element` or "" if no such attribute is present.

    - #### getAriaLiveProperty

          java.lang.String getAriaLiveProperty​(Element element)

      Returns the value of the aria-live attribute for the `element` or "" if no such attribute is present.

    - #### getAriaOwnsProperty

          java.lang.String getAriaOwnsProperty​(Element element)

      Returns the value of the aria-owns attribute for the `element` or "" if no such attribute is present.

    - #### getAriaRelevantProperty

          java.lang.String getAriaRelevantProperty​(Element element)

      Returns the value of the aria-relevant attribute for the `element` or "" if no such attribute is present.

    - #### getName

          java.lang.String getName()

      Gets the ARIA 'role' attribute name as defined in the WAI-ARIA standard.
      See Also:
        Roles documentation

    - #### getTabindexExtraAttribute

          java.lang.String getTabindexExtraAttribute​(Element element)

      Returns the value of the tabIndex attribute for the `element` or "" if no such attribute is present.

    - #### remove

          void remove​(Element element)

      Removes the 'role' attribute from the `element`.
      See Also:
        Roles documentation

    - #### removeAriaAtomicProperty

          void removeAriaAtomicProperty​(Element element)

      Removes the aria-atomic attribute from the `element`.

    - #### removeAriaBusyState

          void removeAriaBusyState​(Element element)

      Removes the aria-busy attribute from the `element`.

    - #### removeAriaControlsProperty

          void removeAriaControlsProperty​(Element element)

      Removes the aria-controls attribute from the `element`.

    - #### removeAriaDescribedbyProperty

          void removeAriaDescribedbyProperty​(Element element)

      Removes the aria-describedby attribute from the `element`.

    - #### removeAriaDisabledState

          void removeAriaDisabledState​(Element element)

      Removes the aria-disabled attribute from the `element`.

    - #### removeAriaDropeffectProperty

          void removeAriaDropeffectProperty​(Element element)

      Removes the aria-dropeffect attribute from the `element`.

    - #### removeAriaFlowtoProperty

          void removeAriaFlowtoProperty​(Element element)

      Removes the aria-flowto attribute from the `element`.

    - #### removeAriaGrabbedState

          void removeAriaGrabbedState​(Element element)

      Removes the aria-grabbed attribute from the `element`.

    - #### removeAriaHaspopupProperty

          void removeAriaHaspopupProperty​(Element element)

      Removes the aria-haspopup attribute from the `element`.

    - #### removeAriaHiddenState

          void removeAriaHiddenState​(Element element)

      Removes the aria-hidden attribute from the `element`.

    - #### removeAriaInvalidState

          void removeAriaInvalidState​(Element element)

      Removes the aria-invalid attribute from the `element`.

    - #### removeAriaLabelledbyProperty

          void removeAriaLabelledbyProperty​(Element element)

      Removes the aria-labelledby attribute from the `element`.

    - #### removeAriaLabelProperty

          void removeAriaLabelProperty​(Element element)

      Removes the aria-label attribute from the `element`.

    - #### removeAriaLiveProperty

          void removeAriaLiveProperty​(Element element)

      Removes the aria-live attribute from the `element`.

    - #### removeAriaOwnsProperty

          void removeAriaOwnsProperty​(Element element)

      Removes the aria-owns attribute from the `element`.

    - #### removeAriaRelevantProperty

          void removeAriaRelevantProperty​(Element element)

      Removes the aria-relevant attribute from the `element`.

    - #### removeTabindexExtraAttribute

          void removeTabindexExtraAttribute​(Element element)

      Removes the tabIndex attribute from the `element`.

    - #### set

          void set​(Element element)

      Sets the 'role' attribute of the given `element` to the appropriate value for this role.
      See Also:
        Roles documentation

    - #### setAriaAtomicProperty

          void setAriaAtomicProperty​(Element element,
                                     boolean value)

      Sets the aria-atomic attribute for the `element` to the given `value`.

    - #### setAriaBusyState

          void setAriaBusyState​(Element element,
                                boolean value)

      Sets the aria-busy attribute for the `element` to the given `value`.

    - #### setAriaControlsProperty

          void setAriaControlsProperty​(Element element,
                                       Id... value)

      Sets the aria-controls attribute for the `element` to the given `value`.

    - #### setAriaDescribedbyProperty

          void setAriaDescribedbyProperty​(Element element,
                                          Id... value)

      Sets the aria-describedby attribute for the `element` to the given `value`.

    - #### setAriaDisabledState

          void setAriaDisabledState​(Element element,
                                    boolean value)

      Sets the aria-disabled attribute for the `element` to the given `value`.

    - #### setAriaDropeffectProperty

          void setAriaDropeffectProperty​(Element element,
                                         DropeffectValue... value)

      Sets the aria-dropeffect attribute for the `element` to the given `value`.

    - #### setAriaFlowtoProperty

          void setAriaFlowtoProperty​(Element element,
                                     Id... value)

      Sets the aria-flowto attribute for the `element` to the given `value`.

    - #### setAriaGrabbedState

          void setAriaGrabbedState​(Element element,
                                   GrabbedValue value)

      Sets the aria-grabbed attribute for the `element` to the given `value`.

    - #### setAriaHaspopupProperty

          void setAriaHaspopupProperty​(Element element,
                                       boolean value)

      Sets the aria-haspopup attribute for the `element` to the given `value`.

    - #### setAriaHiddenState

          void setAriaHiddenState​(Element element,
                                  boolean value)

      Sets the aria-hidden attribute for the `element` to the given `value`.

    - #### setAriaInvalidState

          void setAriaInvalidState​(Element element,
                                   InvalidValue value)

      Sets the aria-invalid attribute for the `element` to the given `value`.

    - #### setAriaLabelledbyProperty

          void setAriaLabelledbyProperty​(Element element,
                                         Id... value)

      Sets the aria-labelledby attribute for the `element` to the given `value`.

    - #### setAriaLabelProperty

          void setAriaLabelProperty​(Element element,
                                    java.lang.String value)

      Sets the aria-label attribute for the `element` to the given `value`.

    - #### setAriaLiveProperty

          void setAriaLiveProperty​(Element element,
                                   LiveValue value)

      Sets the aria-live attribute for the `element` to the given `value`.

    - #### setAriaOwnsProperty

          void setAriaOwnsProperty​(Element element,
                                   Id... value)

      Sets the aria-owns attribute for the `element` to the given `value`.

    - #### setAriaRelevantProperty

          void setAriaRelevantProperty​(Element element,
                                       RelevantValue... value)

      Sets the aria-relevant attribute for the `element` to the given `value`.

    - #### setTabindexExtraAttribute

          void setTabindexExtraAttribute​(Element element,
                                         int value)

      Sets the tabIndex attribute for the `element` to the given `value`.